;;;=====================================================================;;;
;;; TAKEO.LSP                                                           ;;;
;;; Bir veri dosyasinda yazili takeometrik alim degerlerini kullanarak  ;;;
;;; poligon ve noktalarin 3 boyutlu dokumunu yapar                      ;;;
;;; Ornek veri dosyasi: Koord.dat                                       ;;;
;;; Hazirlayan: M. Sahin Guvercin                                       ;;;
;;; sahinguvercin@hotmail.com                                           ;;;
;;;=====================================================================;;;
(defun C:TAKEO ()
  (setvar "cmdecho" 0) (command "undo" "group")
  (setq blp (getvar "blipmode")) (setvar "blipmode" 0)
  (if (= nil olc) (setq molc (getvar "ltscale")))
  (if (= nil (tblsearch "LAYER" "Nokta")) (command "layer" "n" "Nokta" "c" "2" "Nokta" ""))
  (if (= nil (tblsearch "LAYER" "NoktaNo")) (command "layer" "n" "NoktaNo" "c" "1" "NoktaNo" ""))
  (if (= nil (tblsearch "LAYER" "NoktaKotu")) (command "layer" "n" "NoktaKotu" "c" "3" "NoktaKotu" ""))
  (if (= nil (tblsearch "LAYER" "Poligon")) (command "layer" "n" "Poligon" "c" "1" "Poligon" ""))
  (command "layer" "f" "Nokta,NoktaNo" "")
  (setq support (strcat (vl-filename-directory (findfile "acad.exe")) "\\support")
        girkut (getfiled "Veri Kt" support "dat" 2) f (open girkut "r") nsayi 0 pol 0
  )
  (if (= molc nil) (setq molc 1.00))
  (setq olc (getreal (strcat "\n Cizim olcegi 1/<" (rtos molc 2 2) "> : ")))
  (if (= nil olc) (setq olc molc))
  (setvar "ltscale" olc)
  (setq cd (* (/ 0.25 1000) olc) th (* (/ 1.0 1000) olc) molc olc)
  (setvar "clayer" "poligon")
  (while (= (read (setq sat (read-line f))) '*)
    (setq nok (temiz (substr sat 2 9)) pt (list (atof (substr sat 11 10)) (atof (substr sat 21 10)))
          dyuk (atof (substr sat 31 10)) pl (cons (list nok pt) pl) pol (1+ pol)
    )
    (yaz dyuk pt nok)
  )
  (setvar "clayer" "0") (gayar)
  (while sat
    (setq bnok (temiz (substr sat 6 5)))
    (if (= (substr bnok 1 1) "P") (setq n2 (cadr (assoc bnok pl))))
    (if (= (substr sat 1 1) "P")
      (progn (setq dnok (temiz (substr sat 1 5)) n1 (cadr (assoc dnok pl)) baci (angle n1 n2)))
    )
    (princ (strcat "\r" (strcat "Durulan nokta: " dnok) "   " (strcat "Bakilan nokta: " bnok) "   "))
    (if (/= (substr bnok 1 1) "P")
      (progn
        (setq aci1 (/ (atof (substr sat 11 10)) (/ 200 pi))
              yaci (- baci aci1)
              mesa (atof (substr sat 21 10))
              pt (polar n1 yaci mesa)
              dyuk (atof (substr sat 31 10))
        )
        (yaz dyuk pt bnok)
      )
    )
    (setq sat (read-line f))
  )
  (gayar)
  (princ (strcat "\n " (itoa pol) " adet Poligon kullanilarak, " (itoa nsayi) " adet nokta dokumu yapildi."))
  (setvar "blipmode" blp) (command "undo" "e") (prin1)
)
(defun temiz (str)
(setq l (strlen str) nl 0 tmz "")
(while (< nl l)
  (setq nl (1+ nl))
  (if (/= " " (setq el (substr str nl 1))) (setq tmz (strcat tmz el)))
)
(setq str tmz)
)
(defun yaz (dyuk pt nok)
  (setq nsayi (1+ nsayi))
  (if (= "Poligon" (getvar "clayer")) (setq ly "Poligon") (setq ly "Nokta"))
  (entmake (list (cons 0 "CIRCLE") (cons 8 ly) (cons 10 (list (car pt) (cadr pt) dyuk)) (cons 40 cd)))
  (if (= "Poligon" (getvar "clayer")) (setq ly "Poligon") (setq ly "NoktaNo"))
  (entmake (list (cons 0 "TEXT") (cons 67 0) (cons 8 ly) (cons 10 (list (car pt) (cadr pt) dyuk)) (cons 40 th)
                 (cons 1 nok) (cons 50 0.0) (cons 41 1.0) (cons 51 0.0) (cons 71 0) (cons 72 0) (cons 73 0)))
  (entmake (list (cons 0 "TEXT") (cons 67 0) (cons 8 "NoktaKotu") (cons 10 (list (car pt) (cadr pt) dyuk))
                 (cons 40 th) (cons 1 (rtos dyuk 2 2)) (cons 50 0.0) (cons 41 1.0) (cons 51 0.0) (cons 71 0)
                 (cons 72 0) (cons 73 0)))
)
(defun gayar ()
  (command "zoom" "e")
  (setq lan (getvar "extmin") run (getvar "extmax") dlx (* (distance lan run) 0.15) rt (angle lan run)
        kose1 (polar lan (+ rt pi) dlx) kose2 (polar run rt dlx)
        ctr (list (/ (+ (car kose1) (car kose2)) 2) (/ (+ (cadr kose1) (cadr kose2)) 2))
        hei (- (cadr kose2) (cadr kose1)) wdt (- (car kose2) (car kose1))
        scr (getvar "screensize") orn (/ (car scr) (cadr scr))
  )
  (if (< hei (/ wdt orn)) (setq hei (/ wdt orn)))
  (command "zoom" "w" kose1 kose2)
)